/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumOpthalmicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_RefractiveErrorTypes;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_RefractiveErrorTypes;


/**
 * This class represents RefractiveErrorTypes CID4238
 */
public class RefractiveErrorTypes_CID4238 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new RefractiveErrorTypes_CID4238 Template 
	 */
	public RefractiveErrorTypes_CID4238()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumRefractiveErrorTypes Object of EnumCM_RefractiveErrorTypes represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_RefractiveErrorTypes enumRefractiveErrorTypes)
	{
		switch(enumRefractiveErrorTypes)
		{
		case MYOPIA:
			this.strCodeValue = EnumCV_RefractiveErrorTypes.MYOPIA_DA_74120
					.getValue();
			break;
		case HYPEROPIA:
			this.strCodeValue = EnumCV_RefractiveErrorTypes.HYPEROPIA_DA_74110
					.getValue();
			break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumRefractiveErrorTypes Object of EnumCM_RefractiveErrorTypes represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_RefractiveErrorTypes enumRefractiveErrorTypes)
	{
		switch(enumRefractiveErrorTypes)
		{
		case MYOPIA:
			this.strSNOMEDCTID = EnumOpthalmicSNOMEDMap.MYOPIA.getSNOMEDCTID();
			break;
		case HYPEROPIA:
			this.strSNOMEDCTID = EnumOpthalmicSNOMEDMap.HYPEROPIA.getSNOMEDCTID();
			break;

	
		}
	}

	/**
	 * Sets the value for RefractiveErrorTypes
	 * @param enumRefractiveErrorTypes Object of EnumCM_RefractiveErrorTypes.
	 */
	public void setRefractiveErrorTypes(EnumCM_RefractiveErrorTypes enumRefractiveErrorTypes)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumRefractiveErrorTypes.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumRefractiveErrorTypes);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumRefractiveErrorTypes);
	}
}
